# Gopher

Gopher is an [application layer](l7.md)  protocol (normally on port 70), as well as the whole network built on top this protocol (also called *gopherspace*), for sharing documents on the [Internet](internet.md); it is a simpler alternative to the [World Wide Web](www.md) (which is build on top of [HTTP](http.md) and [HTML](html.md)). Unlike the Web, whose basic paradigm is that of a site, Gopher works with menus and organizes the documents on the Internet into a hierarchy very similar to a [file system](fs.md). For its simplicity Gopher is oftentimes preferred by [suckless](suckless.md) advocates.

Natively browsing Gopher generally requires a special browser, web browsers don't normally come with Gopher support (though there exist browser extensions and web gateway sites). Gopher browsers include [lynx](lynx.md), [sacc](sacc.md) (text browsers) and [forg](forg.md) ([GUI](gui.md)).

Gopher "sites" are identified by [URLs](url.md) similarly to those on the web, but the protocol part is `gopher://` instead of `http://`. Opening such a URL will display the menu or file present at the location -- the menus are simple and can only consist of a number of items without any formatting or graphical effects known from websites. The items can be of several types such as a submenu, text file, info message, image or text input (e.g. for search engines). The source code of menus are called *gophermaps* (similar to [HTML](html.md) on the web but simpler, basically just tab-separated menu items).

Gopher was created in 1991 by a few programmers led by Mark P. McCahill for University of Minnesota, but other organizations soon adopted the system as well. It was kind of revolutionary by bringing and linking together the documents on the Internet in a very comfortable way -- this was all happening alongside the invention of the web with which Gopher initially seriously competed, and it was even leading the race for a while (before the Internet became mainstream, commercialized and as such gave preference to [bloat](bloat.md)).

Some notable Gopher sites are:

- **Floodgap** (popular front page): gopher://gopher.floodgap.com:70/1/
- **Veronica search engine**: gopher://gopher.floodgap.com:70/7/v2/vs
- **Gopherpedia** ([Wikipedia](wikipedia.md) on Gopher): gopher://gopherpedia.com:70/1/
- **[SDF](sdf.md)**: gopher://sdf.org/

TODO: some simple gopher site source code

## See Also

- [Gemini](gemini.md)